/*
   XXX
   Does this implementation play too many dirty tricks with the internals of
   OsaStepsize?  Should I instead add a member function to stepsize that
   adjusts upward its internal estimate?
 */
class LinearTrendingStepsize extends OsaStepsize
{
  DataStream stream;
  private double smoothedTrend;
  private double prevSample;
  /*
   * In this implementation we use constant stepsize exponential smoothing to
   * collect trend information.  In the future we might use something more
   * sophisticated.
   */
  private double trendAlpha = 0.3;
  public LinearTrendingStepsize(DataStream stream)
  {
	  super(stream);
	  smoothedTrend = 0;
	  prevSample = 0;
  }
  public double Update(double sample)
  {
	  // If n==0 we don't have a previous sample and should just leave the
	  // smoothedTrend at 0.
	  if (n > 0) {
		  // trendSample is the discrete derivative.
		  double trendSample = sample - prevSample;
		  smoothedTrend = (1-trendAlpha) * smoothedTrend + 
			  trendAlpha * trendSample;
	  }
	  prevSample = sample;
	  thetabar += smoothedTrend;
	  stream.PutComment(stream.T_STEP, "smoothedTrend = " + smoothedTrend);
	  return super.Update(sample);
  }
}
