/*
 * Abstract stepsize class.  Inheriting from this are various stepsize rules
 * like generalized harmonic stepsizes, and Abraham's optimal stepsize
 * algorithm (OSA).
 */
public abstract class Stepsize
{
  /* 
   * Get the stepsize for iteration n, and update state to be ready for the
   * next stepsize. 
   */
  abstract public double Update(double sample);
};
